#!/usr/bin/env python
# -*- coding: utf8 -*-

import httplib
import json

class Client:
	"""docstring for ClientTransmission"""
	def __init__(self):
		self.clientName = "Transmission"
		self.host = "localhost"
		self.port = "9091" # DSM = 9093


	def output(self):
		return self.clientName;

	def addTorrent(self,torrentURL,ZielPfad):

		print torrentURL

		session = self.getTransmissionSession()

		headers = {"X-Transmission-Session-Id": session}
		params = '{"arguments": {"filename":"'+torrentURL+'", "download-dir": "'+ZielPfad+'"},"method": "torrent-add"}';
		req = httplib.HTTPConnection(self.host+":"+self.port)
		req.request("POST","/transmission/rpc",params,headers)
		res = req.getresponse()
		resjson = res.read()
		jsondata = json.loads(resjson)
		if (jsondata[u'result'] == u'duplicate torrent'):
			return "duplicate"
		else:
			return jsondata[u'arguments'][u'torrent-added'][u'id']
		#return torrentID



	def getTransmissionSession(self):
		req = httplib.HTTPConnection(self.host+":"+self.port)
		req.request("POST","/transmission/rpc")
		res = req.getresponse()
		return res.getheader("X-Transmission-Session-Id")

	def getTorrentStatus(self, torrentID):
		if (torrentID == "duplicate"):
			return "ready"
		else:
			session = self.getTransmissionSession()
			headers = {"X-Transmission-Session-Id": session}
			params = '{	"arguments": { "fields":["percentDone"],"ids":'+str(torrentID)+' }, "method": "torrent-get"}';
			req = httplib.HTTPConnection(self.host+":"+self.port)
			req.request("POST","/transmission/rpc",params,headers)
			res = req.getresponse()
			jsonres = res.read()
			jsondata = json.loads(jsonres)
			status = jsondata[u'arguments'][u'torrents'][0][u'percentDone']
			if (status == 1):
				return "ready"
			else:
				return "loading"

	
		

