#!/usr/bin/env python
# -*- coding: utf8 -*-

import basefeed

class AtomFeed(basefeed.BaseFeed):
	""" Ist für Atom-Feeds zuständig. Das mit '{http://www.w3.org/2005/Atom}' ist etwas eklig,
		aber wohl 'safe' und korrekt so.
	"""

	def isApplicable(self, feed):
		return ('atom' in feed.getroot().tag.lower())
		
	def setSelfReference(self, feed, url):
		for element in feed.getroot().findall('{http://www.w3.org/2005/Atom}link'):
			if(element.get('rel') == 'self'):
				element.set('href', url)

		
	def getItems(self, feed):
		result = []
		for entry in feed.iter('{http://www.w3.org/2005/Atom}entry'):
			result.append(entry)
		return result

	def getEnclosures(self, item):
		result = []
		for link in item.iter('{http://www.w3.org/2005/Atom}link'):
			if(link.get('rel') == 'enclosure'):
				result.append(link)
		return result
		
	def getUrlOfEnclosure(self, enclosure):
		return enclosure.get('href')

	def getTypeOfEnclosure(self, enclosure):
		return enclosure.get('type')

	def setUrlOfEnclosure(self, enclosure, url):
		enclosure.set('href', url)

	def setTypeOfEnclosure(self, enclosure, inType):
		enclosure.set('type', inType)
