#!/usr/bin/env python
# -*- coding: utf8 -*-

import basefeed

class RSSFeed(basefeed.BaseFeed):

	def isApplicable(self, feed):
		return ('rss' in feed.getroot().tag.lower())
	
	def setSelfReference(self, feed, url):
		# Wenn es ein kombinierter feedburner-Feed ist, hat er auch dieses Element
		for element in feed.getroot().getchildren()[0].findall('{http://www.w3.org/2005/Atom}link'):
			if(element.get('rel') == 'self'):
				element.set('href', url)
		
		# Spezielles iTunes-Kontroll-Element
		for element in feed.getroot().getchildren()[0].findall('{http://www.itunes.com/dtds/podcast-1.0.dtd}new-feed-url'):
			element.text = url

	def getItems(self, feed):
		result = []
		for item in feed.iter('item'):
			result.append(item)
		return result

	def getEnclosures(self, item):
		result = []
		for enclosure in item.iter('enclosure'):
			result.append(enclosure)
		return result
	
	def getUrlOfEnclosure(self, enclosure):
		return enclosure.get('url')

	def getTypeOfEnclosure(self, enclosure):
		return enclosure.get('type')

	def setUrlOfEnclosure(self, enclosure, url):
		enclosure.set('url', url)

	def setTypeOfEnclosure(self, enclosure, inType):
		enclosure.set('type', inType)
