#!/usr/bin/env python
# -*- coding: utf8 -*-

import time
import BaseHTTPServer
import mimetypes
import urllib
import urlparse
import ConfigParser
import re
import xml.etree.ElementTree as ET
import os
import feedmanipulator
import time
import bitloveUrlParser
import threading
from SocketServer import ThreadingMixIn



# Lade Konfiguration aus der Datei 'config.cfg'
config = ConfigParser.ConfigParser()
config.read(os.path.dirname(os.path.abspath(__file__)) + "/config.cfg")
HOST_NAME = config.get("Konfiguration", "HOST_NAME")
PORT_NUMBER = config.getint("Konfiguration", "PORT_NUMBER")
EXTERN_HOST_NAME = config.get("Konfiguration", "EXTERN_HOST_NAME")
EXTERN_PORT_NUMBER = config.getint("Konfiguration", "EXTERN_PORT_NUMBER")
DOCROOT = config.get("Konfiguration", "DOCROOT")
TORRENT_CLIENT = config.get("Konfiguration", "TORRENT_CLIENT")

#Klasse für den Torrentclient laden
TClient = __import__("Client"+TORRENT_CLIENT)


def read_in_chunks(file_object, chunk_size=1024):
    """Lazy function (generator) to read a file piece by piece.
    Default chunk size: 1k."""
    while True:
        data = file_object.read(chunk_size)
        if not data:
            break
        yield data

def read_range(file_object, infrom, into):
    """Funktion um Dateiranges auszuliefern"""
    data = file_object.seek(infrom)
    data = file_object.read(into - infrom + 1)
    yield data

class MyHandler(BaseHTTPServer.BaseHTTPRequestHandler):
	def do_GET(self):
		# Entscheiden, ob wir einen Feed ausliefern oder eine Datei angefragt ist.
		#welcher modus wird angefragt
		requestpath = self.path.split("/",2)



		print "self.path: " + self.path + "\n laenge" + str(len(requestpath)) +"\n"


		#nur wenn gültige anfrage abschicken

		if (len(requestpath) == 3):
			global modus
			modus = requestpath[1] #modus
			global parameter
			parameter = requestpath[2] #uebergebene parameter


			#modus: "load" -> lokale Datei laden
			#modus: "torrent" -> torrent laden
			#modus: "http:" oder "https:" feed laden


			print "modus: " + modus + "\n"
			print "parameter: " + parameter + "\n"
			print "self.path: " + self.path + "\n"

			if(modus == "load"):
				#Datei Existiert - also Ausliefern
				self.returnFile()
			else:
				#Keine Datei. Torrentfile oder Feed
				if(modus == "torrent"):
					self.loadTorrent()
				else:
					self.returnFeed()
    
    
	def returnFile(self):
		"""Liefer eine Binärdatei aus, die im Unterverzeichnis vom Doc-Root liegen muss."""
		# Sicherstellen, dass die Datei existiert (nicht MEGA-sicher, aber reicht.)
		# Warum, siehe: http://stackoverflow.com/questions/82831/how-do-i-check-if-a-file-exists-using-python

		localfilepath = DOCROOT + "/" + parameter # locale Pfad-url zusammenbauen

		if((not os.path.isfile(localfilepath)) or (not DOCROOT in os.path.abspath(localfilepath))):
			self.send_error(404)
			return False
		
		#Range Header heraussuchen
		reqRange = self.headers.get("Range")
		
		#Testen ob der Range-Header gesetzt ist
		if (reqRange == None):

			# Range-Header ist nicht gesetzt ganze Datei ausliefern
			self.send_response(200)
			contentType = mimetypes.guess_type(localfilepath)[0] # Mimetype herausfinden
			if (contentType == None):
				contentType = "application/octet-stream" #wenn Mimetype None - setzen
			file_stat = os.stat(localfilepath)
			self.send_header('Content-Type', contentType)
			self.send_header('Content-Length', file_stat.st_size)
			self.send_header('Accept-Ranges', 'bytes')
			self.end_headers()
			
			f=open(localfilepath, 'rb')
		
			for piece in read_in_chunks(f):
				self.wfile.write(piece)
				self.wfile.flush()
			
			f.close()

		else:

			#Range Ausliefern
			#Range Parsen
			byteRange = reqRange.split("bytes=")[1]
			startBytes = byteRange.split("-")[0]
			endBytes = byteRange.split("-")[1]

			file_size = os.stat(localfilepath).st_size

			#unvollständig nachgefragte Ranges zusammenbauen
			if (startBytes == ""):
				startBytes = 0
			else:
				startBytes = int(startBytes)
			if (endBytes == ""):
				endBytes = file_size-1
				endBytes = int(endBytes)
				if (endBytes > file_size-1):
					endBytes = file_size-1
			else:
				endBytes = int(endBytes)

			# Datei ausliefern
			self.send_response(206)
			contentType = mimetypes.guess_type(localfilepath)[0] # Mimetype herausfinden
			if (contentType == None):
				contentType = "application/octet-stream" #wenn Mimetype None - setzen
			self.send_header('Content-Type', contentType)
			self.send_header('Content-Length', str(endBytes - startBytes + 1))
			self.send_header('Accept-Ranges', 'bytes')
			self.send_header('Content-Range', 'bytes ' + str(startBytes) + "-" + str(endBytes) + "/" + str(file_size))
			self.end_headers()
			
			f=open(localfilepath, 'rb')
		
			for piece in read_range(f,startBytes,endBytes):
				self.wfile.write(piece)
				self.wfile.flush()
			
			f.close()


		
		return
    
	def loadTorrent(self):
		

		torrentURL = self.path.split("/torrent/",1)[1] + ".torrent"

		bitloveURL = bitloveUrlParser.BitloveUrlParser(torrentURL)
		directory = bitloveURL.getPath()


		torrentklasse = TClient.Client()
		#Torrent hinzufügen
		tid = torrentklasse.addTorrent(torrentURL,DOCROOT + directory)
		#testen ob Torrent schon fertig geladen
		while (torrentklasse.getTorrentStatus(tid)=="loading"):
			time.sleep(1)
		
		#weiterleitung auf lokale Datei setzen
		self.send_response(307)
		self.send_header("Location", 'http://' + EXTERN_HOST_NAME + ':' + str(EXTERN_PORT_NUMBER) + "/load"+ directory + "/" + self.path.split("/")[-1])
		self.end_headers()

		
		self.wfile.close()

		return


	def returnFeed(self):
		"""Nimm den RSS-Feed, der für das Verzeichnis vorgesehen ist, lade ihn, manipuliere ihn und liefer ihn aus."""

		# Den Pfad in Ordner und Feed separieren
		params = self.path.split("/",1)
		if(len(params) != 2):
			self.send_error(404)
			return False
			
		feedurl = params[1]
		feedurl = feedurl.replace("https://","http://",1)
		
		#Lokaler Pfad aus Bitlove URL
		bitloveURL = bitloveUrlParser.BitloveUrlParser(feedurl)
		directory = bitloveURL.getPath()

		# Pfad normalisieren
		if(not directory.endswith("/")):
			directory += "/"
		print directory
		# Sicherstellen, dass der Pfad gültig und unter dem DOCROOT ist (../ nützen also nichts)
		if((not os.path.isdir(DOCROOT + directory)) or (not DOCROOT in os.path.abspath(DOCROOT + directory))):
			self.send_error(404)
			return False
		
		# Extrahiere die URL aus der Info-Datei
		
		# Lade den RSS-Feed
		feed = urllib.urlopen(feedurl)		
		tree = ET.parse(feed) # Feed-Tree erstellen
		feed.close()

		mani = feedmanipulator.Feedmanipulator()
		newfeed = mani.modifyFeed(tree, DOCROOT, directory, 'http://' + EXTERN_HOST_NAME + ':' + str(EXTERN_PORT_NUMBER), feedurl)
		
		# Schick die Antwort raus
		self.send_response(200)
		self.send_header("Content-type", "text/xml")
		#self.send_header('Content-Length', len(feedcontent))
		self.end_headers()
		newfeed.write(self.wfile) # Schreibe das Dokument als Antwort raus
		return


#Parallele Requests ermöglichen
class ThreadedHTTPServer(ThreadingMixIn, BaseHTTPServer.HTTPServer):
    """Handle requests in a separate thread.""" 
    pass   	

if __name__ == '__main__':
	# Mimetypes vorbereiten, damit man HTTP-Header generieren kann
	mimetypes.init()

	# Server starten
	httpd = ThreadedHTTPServer((HOST_NAME, PORT_NUMBER), MyHandler)
	httpd.allow_reuse_address = True
	print time.asctime(), "Server Starts - %s:%s" % (HOST_NAME, PORT_NUMBER)
	try:
		httpd.serve_forever()
	except KeyboardInterrupt:
		pass
	httpd.server_close()
	print time.asctime(), "Server Stops - %s:%s" % (HOST_NAME, PORT_NUMBER)

